<template>
  <div class="checkout-auth">
    <form v-show="step === 1"
          novalidate
          @submit.prevent="sendPhoneForm"
          class="checkout-auth__form"
    >

      <form-input class="checkout-auth__phone"
                  v-model="phone"
                  :error="phoneError"
                  :label="phoneError ? `Телефон введен неверно` : 'Введите телефон'"
                  :mask="true"
                  mask-type="phone-mask"
      />

      <button type="submit"
              class="button button--green checkout-auth__btn">
        Отправить код
      </button>

      <recaptcha @error="onError" @success="onSuccessPhone" @expired="onExpired" />
    </form>

    <form v-show="step === 2"
          class="checkout-auth__form"
    >

      <form-input class="checkout-auth__code"
                  :error="codeError"
                  :label="codeError ? 'Код введен неверно' : 'Введите код из смс'"
                  type="password"
                  v-model="code"
                  :mask="true"
                  mask-type="sms-code-mask"
      />

      <button type="button"
              class="button button--green checkout-auth__btn"
              @click="sendPhoneForm()"
              :disabled="timerCount > 0"
      >
        Отправить еще раз
        <template v-if="timerCount > 0">
          ({{ `0${Math.floor(timerCount / 60)}:${timerCount % 60 >= 10 ? `${timerCount % 60}` : `0${timerCount % 60}`}`}})
        </template>
      </button>
    </form>


  </div>
</template>

<script>
  import { mapActions } from 'vuex';

  import FormInput from './FormInput';

  import { login as loginRequest } from '../service/deliroom-service';

  export default {
    name: 'CheckoutAuth',
    components: {
      FormInput
    },
    props: {
      rights: {
        type: Boolean,
        default: true,
      }
    },
    data: () => ({
      phone: '',
      maskedPhone: '',
      sendedPhone: '',
      captchaPhone: '',
      code: '',
      step: 1,
      phoneError: false,
      codeError: false,
      timerCount: 0,
    }),
    watch: {
      phone() {
        this.phoneError = false;
      },

      code(val) {
        if (val.length === 4) this.sendCodeForm();

        this.codeError = false;
      },

      rights(val) {
        if (val && this.code.length === 4) this.sendCodeForm();
      }
    },
    methods: {
      ...mapActions({
        authRequest: 'auth/authRequest'
      }),

      onError(error) {
        console.log('Error happened:', error)
      },

      async onSuccessPhone() {
        const timer = setInterval(async () => {
          if (this.captchaPhone) {
            clearInterval(timer);

            await this.getCodeByPhone();
          }
        }, 100);
      },

      onExpired() {
        console.log('Expired')
      },

      async sendPhoneForm() {
        if (this.phone.length && this.sendedPhone === this.phone && this.step === 1) {
          this.goToStep(2);

          return;
        }

        if (!this.phone) {
          this.phoneError = true;
          return;
        }

        if (!this.rights) {
          this.$notify({
            group: 'errors',
            type: 'error',
            title: `Ошибка`,
            text: 'Не дано согласие на обработку данных',
          });

          return;
        }

        this.captchaPhone = '';

        try {
          this.captchaPhone = await this.$recaptcha.getResponse();
          await this.$recaptcha.reset()
        } catch (error) {
          console.log('Login error:', error)
        }
      },

      async sendCodeForm() {
        if (!this.rights) {
          this.$notify({
            group: 'errors',
            type: 'error',
            title: `Ошибка`,
            text: 'Не дано согласие на обработку данных',
          });

          return;
        }

        await this.login();
      },

      async getCodeByPhone() {
        const res = await loginRequest({ phone: `+7${ this.phone }`, captcha: this.captchaPhone });

        if (res.errors || res.error) {
          this.phoneError = true;
          console.error(res.errors);

          return;
        }

        const expiredAt = (new Date(res.data.expired_at) - new Date()) / 1000;

        this.sendedPhone = this.phone;
        this.startCounting(expiredAt);
        this.maskedPhone = this.$el.querySelector('.checkout-auth__phone input').value;
        this.goToStep(2);
      },

      async login() {
        const res = await this.authRequest({
          phone: `+7${ this.phone }`,
          sms_code: this.code
        });

        if (res.error) {
          this.codeError = true;
          console.error(res.error);

          return;
        }
      },

      goToStep(step) {
        this.step = step;
        this.code = '';
      },

      startCounting(count = 60) {
        this.timerCount = Math.ceil(count);

        const timer = setInterval(() => {
          this.timerCount--;

          if (this.timerCount <= 0) {
            clearInterval(timer)
          }
        }, 1000)
      }
    }
  }
</script>

<style scoped lang="scss">
  @import '~assets/scss/variables.scss';
  @import '~assets/scss/mixins.scss';

  .checkout-auth {
    display: flex;
    flex-flow: wrap;

    &__form {
      display: flex;

      width: 100%;

      @media (max-width: $mobile-width) {
        flex-flow: wrap;
      }
    }

    &__phone {
      flex: 0 0 rem(468);
      width: rem(468);

      @media (max-width: $mobile-width) {
        flex: 0 0 100%;
        width: 100%;
      }
    }

    &__code {
      flex: 0 0 50%;
      width: 50%;

      @media (max-width: $mobile-width) {
        flex: 0 0 100%;
        width: 100%;
      }
    }

    &__btn {
      flex: 1 1;
      height: rem(70);
      margin-left: rem(28);

      @media (max-width: $mobile-width) {
        margin-left: 0;
        margin-top: rem(14);
      }
    }

    &__rights {
      margin-top: rem(36);

      .checkbox__label {
        max-width: rem(440);
      }
    }
  }

</style>
